/*
 *				**** MATCH ****
 *
 * This file contains routines to perform match-up questions
 *
 */

#include "quiz.h"

static	char	*ans = "abcdefghijklmnopqrstuvwxyz";

match(FILE *fp)
{
	int num_quest=0, num_right=0;		/* number questions & number right */
	int errs;							/* number of errors */
	char buf[BUFSIZ];

	do
	{ /* loop asking multiple choice until the user quits */
		errs = do_match(fp);
		num_quest += NUMANS;
		num_right += NUMANS - errs;

		if (errs)
		{ /* missed last question */
			printf("Sorry!");
		} else printf("Very Good!");
		printf(" That's %d out of %d so far.\n", num_right, num_quest);

		printf("Press ENTER for another question, or type 'q' to quit\n");
		gets(buf);
	} while (*buf != 'q' && *buf != 'Q');

	return (num_right * 100 / num_quest);
}


do_match(FILE *fp)
{
	int i, j, k, errs;
	int Correct[NUMANS];		/* correct answers */
	int Response[NUMANS];		/* user responses */
	char buf[BUFSIZ];

	get_nums(NUMANS);		/* get 4 questions */

	/* make a copy of the questions and shuffle them */
	for (i=0; i < NUMANS; i++) Correct[i] = i;
	for (i=NUMANS-1; i > 0; i--)
	{ /* pick a random answer to move to the top */
		j = random(i);		/* select answer to move to top */
		k = Correct[i];		/* save old top */
		Correct[i] = Correct[j]; /* move selected answer to top */
		Correct[j] = k;		/* move old top into selected space */
	}

	/* now print answers followed by answers */

	for (i=0; i < NUMANS; i++)
	{
		printf("%c. ", ans[i]);
		put_line(fp,stdout, Quiz[Nums[Correct[i]]].q_w);
	}

	printf("\n");

	for (i=0; i < NUMANS; i++)
	{
		printf("%d. ", i+1);
		put_line(fp, stdout, Quiz[Nums[i]].q_d);
	}
	printf("\n");

	for (i=0; i < NUMANS; i++)
	{
		printf("What number does letter '%c' match: ", ans[i]);
		gets(buf);
		j = atoi(buf) - 1;
		if (j >=0 && j < NUMANS) Response[i] = j;
		else
		{ /* bad number */
			printf("Invalid response.  Try again.\n");
			i--;
		}
	}

	for (errs=i=0; i < NUMANS; i++)
	{
		if (Response[i] != Correct[i])
		{ /* miss */
			printf("Sorry - Letter %c matches number %d\n",
				ans[i], Correct[i]+1);
			errs++;
		}
	}
	return errs;
}
