/*
 *			**** MULT - MULTIPLE CHOICE ****
 *
 * This routine creates multiple choice questions
 *
 */

#include "quiz.h"

static	char	*ans = "abcdefghijklmnopqrstuvwxyz";

mult(FILE *fp)
{
	char	buf[BUFSIZ];		/* input buffer */
	int		quest;				/* actual question */
	int		nq, nr;				/* number questions & right */

	nq = nr = 0;

	do
	{		/* loop giving questions */
		quest  = ask_multi(fp,stdout);	/* display multiple choice */

		printf("Choose: ");
		gets(buf);			/* get guess */

		if (*buf == ans[quest])
		{		/* correct answer */
			printf("Correct!  Very Good!\n");
			nr++;
		} else
		{
			printf("I'm sorry, but the answer is %c.\n", ans[quest]);
		}

		printf("That's %d out of %d so far!\n", nr, ++nq);

		printf("Press ENTER for another question, or type 'q' to quit\n");
		gets(buf);
	} while (*buf != 'q' && *buf != 'Q');
	return (nr * 100 / nq);
}

fmult(FILE *ifp)
{		/* write multiple choice to a file */
	FILE	*qfp;				/* question file */
	FILE	*afp;				/* answer file */
	char	buf[BUFSIZ];		/* input buffer */
	int		quest;				/* correct answer */
	int		nq;					/* number of questions to ask */
	int		i;					/* loop variable */

	printf("Enter base name of output file (1-8 chars): ");
	gets(buf);
	strcat(buf,".mqf");		/* name of mult. question file */
	if ((qfp = fopen(buf,"w")) == NULL)
	{		/* can't open file */
		fprintf(stderr,"Can't open question file %s for output.\n", buf);
		return 1;
	} else
	{
		strcpy(buf+strlen(buf)-4,".maf");	/* answer file */
		if ((afp = fopen(buf,"w")) == NULL)
		{
			fprintf(stderr,"Can't open answer file %s for output.\n", buf);
			return 2;
		}
	}

	printf("There are %d entries.  How many questions do you want? :", TotQuest);
	gets(buf);
	if ((nq = atoi(buf)) < 1)
	{		/* no questions asked for */
		fprintf(stderr,"%d is an invalid response.\n", nq);
		return 3;
	}

	for (i=0; i < nq; i++)
	{		/* write question */
		fprintf(qfp,"\n%d. ", i+1);		/* number question */
		quest = ask_multi(ifp,qfp);
		fprintf(afp,"%d. %c\n", i+1, ans[quest]);
	}

	fclose(qfp);
	fclose(afp);

	return 0;
}

ask_multi(FILE *ifp, FILE *ofp)
{		/* display multiple choice question */
	int		i;					/* loop variable  */
	int		quest;		/* correct answer */

	get_nums(NUMANS);				/* get 4 questions */

	quest = random(NUMANS);			/* get questin to ask */

	put_line(ifp,ofp,Quiz[Nums[quest]].q_w);	/* print line */

	for (i=0; i < NUMANS; i++)
	{
		fprintf(ofp,"%c. ", ans[i]);
		put_line(ifp,ofp,Quiz[Nums[i]].q_d);	/* print answer */
	}
	return quest;
}
