/*
 *				**** Q&A - Question and Answer ****
 *
 * This routine gives questions and asks for answers
 *
 */

#include "quiz.h"

qna(FILE *fp)
{
	char	buf[BUFSIZ], ans[BUFSIZ];
	int		quest;
	int		nq, nr;		/* number of questions & number right */

	nr = nq = 0;

	do
	{		/* loop giving questions/answers */
		quest = rand() % TotQuest;		/* get question */
		put_line(fp,stdout,Quiz[quest].q_d);	/* write definition */
		fseek(fp,Quiz[quest].q_w,SEEK_SET);		/* where answer is */
		get_line(buf,BUFSIZ,fp);		/* get word */
		printf("\nEnter answer: ");		/* prompt user */
		get_line(ans,BUFSIZ,stdin);		/* get answer from user */
		if (chkans(buf,ans))
		{		/* correct */
			printf("Correct!  Very Good!\n");
			nr++;
		} else
		{
			printf("I'm sorry, the correct answer is %s.\n", buf);
		}

		printf("That's %d out of %d so far!\n", nr, ++nq);

		printf("Press ENTER for next question, or type 'q' to quit: ");
		gets(buf);
	} while (*buf != 'q' && *buf != 'Q');
	return (nr * 100 / nq);
}

chkans(char *ans,char *resp)
{		/* check response with answer */
	char	*p, *q;	/* pointers for scanning */

	p = ans;		/* start at front of answer(s) */

	while (*p != '\0')
	{		/* while answers left */
		for (q = p; *q != '\0' && *q != '|'; q++);	/* find end */
		if (*q != '\0') *q++ = '\0';			/* more to come */
		if (stricmp(resp,p) == 0) return 1;		/* correct */
		p = q;									/* next answer */
	}
	return 0;		/* no match found */
}
