/*
 *				**** QUIZ ****
 *
 * This program quizes the user in several ways.
 * Questions are located in a data file with the following format:
 *
 * Question (one line)
 * Answer (as many lines as needed)
 * <blank line>
 * Question (one line)
 * Answer ...
 * <blank line>
 * etc.
 *
 *
 */


#include "quiz.h"

main(int argc, char **argv)
{
	char	*Prog;				/* program name */
	char	buf[BUFSIZ];		/* input buffer */
	int		opt;				/* option */
	int		pct;				/* percent from routines */
	FILE	*fp;				/* input file */

	if ((Prog = strrchr(argv[0],'/')) == NULL) Prog = strrchr(argv[0], '\\');
   if (Prog == NULL) Prog = argv[0];
	else Prog++;

	setbuf(stdout, NULL);

	randomize();		/* randomize things */
	right_margin = 75;	/* right margin */

	if (argc > 1)
	{		/* quiz file name given */
		strcpy(buf,argv[1]);
	} else strcpy(buf,"quiz.qiz");

	fp = get_quiz(buf);
	pct = -1;

	do
	{		/* get option and do it */
		printf("Main Menu:\n\n");
		printf("1	Q&A\n");
		printf("2	Multiple Choice\n");
		printf("3	Match Up\n");
		printf("4	Fill in the blanks\n");
		printf("\n");
		printf("7	New Quiz File\n");
		printf("8	Multiple Choice to a file\n");
		printf("9	Help\n");
		printf("\nQ	Quit\n");
		printf("\nEnter option: ");
		gets(buf);
		opt = atoi(buf);

		switch(opt)
		{
			case 1:		pct = qna(fp); break;
			case 2:		pct = mult(fp); break;
			case 3:		pct = match(fp); break;
			case 4:		fill_blanks(fp); break;

			case 7:		fclose(fp);
						*buf = '\0';
						get_quiz(buf);
						pct = -1;	/* no questions asked */
						*buf = '\0';
						break;
			case 8:     fmult(fp); pct = -1; break;
			case 9:		do_help(); break;
			case 0:		break;
			default:	printf("Try again!\n");
						continue;
		}
		if (pct >= 0)
			printf("You got a score of %d%% on those tests!\n", pct);
	} while (*buf != 'q' && *buf != 'Q');

	fclose(fp);
}
